=== debian/changelog ===
mscp (0.2.4) UNRELEASED; urgency=medium

  * fix password auth does not work (issue #36)
  * add Debian and Devuan to the install dep script (pr #38)
  * fallback to default terminal size on no tty (pr #39)

 -- Ryo Nakamura <upa@haeena.net>  Sat, 08 Nov 2025 19:23:07 +0900

mscp (0.2.3) unstable; urgency=medium

  * bump libssh version to 0.11.2 (#25)
  * adopt new AIO read API of libssh
  * fix path handling when remote dst path has suffix '/' (#24)
  * fix remote path handling including '~' (partially)
  * try pubkey auth first to avoid PerSourcePenalties
  * remove the single-binary version of mscp from release

 -- Ryo Nakamura <upa@haeena.net>  Tue, 12 Aug 2025 18:11:47 +0900

mscp (0.2.2) unstable; urgency=medium

  * bump cmake_minimum_version on libssh (#32)
  * fix quiet mode (#30)
  * use openssl@3 on macOS (#29)
  * add archlinux support (#28)

 -- Ryo Nakamura <upa@haeena.net>  Wed, 16 Apr 2025 17:01:17 +0900

mscp (0.2.1) unstable; urgency=medium

  * fix broken checkpoint files when copying multiple files (#16)
  * fix broken password inputs for resume transfers (#17 and #18)
  * add support [kKmMgG] units for -s, -S, and -b options (#20)
  * change the default min chunk size to 16MB (#20)
  * change the default max chunk size to filesize / (nr_conn * 4) (#20)
  * -s and -S accept integers other than multiples of page sizes (#20)
  * help now shows available ciphers and HMACs (#20)

 -- Ryo Nakamura <upa@haeena.net>  Sat, 11 May 2024 14:49:52 +0900

mscp (0.2.0) unstable; urgency=medium

  * add -J DESTINATION option for ProxyJump (#15)
  * add -o SSH_OPTION option
  * add -L LIMIT_BITRATE option (#14)
  * add keyboard interactive authentication support. Also, we have manually
    tested that mscp works with cisco DUO MFA (#2)
  * remove -H disable host key check option (ssh_config or -o option can do
    this instead)
  * fix copying files of permission r--r--r--
  * update github actions: checkout v3 to v4, and codeql from v2 to v3
  * add ubuntu 24.04 test

 -- Ryo Nakamura <upa@haeena.net>  Mon, 15 Apr 2024 00:05:20 +0900

mscp (0.1.5) unstable; urgency=medium

  * add support for resuming failed transfer (#5 and #10)
  * remove the list structure derived from the linux kernel and refactoring
    for this change.
  * add and fix test cases (changing port number and number of connections)

 -- Ryo Nakamura <upa@haeena.net>  Thu, 14 Mar 2024 12:51:23 +0900

mscp (0.1.4) unstable; urgency=medium

  * add a test for builds on FreeBSD
  * updat container images for tests
  * dropp support for Python bindings
  * clean up error message handling
  * add MSCP_SSH_AUTH_PASSWORD/PASSPHRASE environment variables
    to pass passwords to MSCP without interactive input (issue #9)
  * add a -p option to preserve timestamps
  * add -4 and -6 options to use IPv4 or IPv6, respectively
  * introduc .clang-format, which is derived from the Linux kernel
  * fix the manpage

 -- Ryo Nakamura <upa@haeena.net>  Wed, 07 Feb 2024 15:56:58 +0900

mscp (0.1.3) unstable; urgency=medium

  * add -I option for inserting intervals between SSH attempts (issue #7)
  * add -P option, equivalent to -p (just for compatibility)
  * update libssh to 0.10.6-2-g6f1b1e76 for security fixes
  * cleanup warning messages when scanning source files fails
  * fix wrong destination paths for source paths under '/' (issue #8)
  * reduce memory footprint for coping many (e.g., over 100k) files (issue #8)
  * add SPDX-License-Identifer to the source files
  * add manpage

 -- Ryo Nakamura <upa@haeena.net>  Fri, 12 Jan 2024 22:20:24 +0900

mscp (0.1.2) unstable; urgency=medium

  * Initial release for debian packaging

 -- Ryo Nakamura <upa@haeena.net>  Sun, 10 Dec 2023 21:51:49 +0900
