=== debian/control ===
Source: mscp
Section: net
Priority: optional
Maintainer: Ryo Nakamura <upa@haeena.net>
Build-Depends: debhelper (>= 10~), cmake, zlib1g-dev, libssl-dev, libkrb5-dev
Homepage: https://github.com/upa/mscp
Standards-Version: 4.5.0.3


Package: mscp
Architecture: linux-any
Depends: ${misc:Depends}, ${shlibs:Depends}
Description: mscp, fast file transfer over multiple SSH connections
 mscp transfers files over multiple SSH connections. Multiple threads
 and connections in mscp transfer (1) multiple files simultaneously
 and (2) a large file in parallel. It would shorten the waiting time
 for transferring a lot of/large files over networks.
